Index: trunk/kernel/kern/process.c
===================================================================
--- trunk/kernel/kern/process.c	(revision 485)
+++ trunk/kernel/kern/process.c	(revision 492)
@@ -132,5 +132,5 @@
     // initialize vmm as empty 
     error = vmm_init( process );
-    assert( (error == 0) , __FUNCTION__ , "cannot initialize VMM\n" );
+    assert( (error == 0) , "cannot initialize VMM\n" );
  
 #if (DEBUG_PROCESS_REFERENCE_INIT & 1)
@@ -175,6 +175,6 @@
                            &stdin_id );
 
-        assert( (error == 0) , __FUNCTION__ , "cannot open stdin pseudo file" );
-        assert( (stdin_id == 0) , __FUNCTION__ , "stdin index must be 0" );
+        assert( (error == 0) , "cannot open stdin pseudo file" );
+        assert( (stdin_id == 0) , "stdin index must be 0" );
 
 #if (DEBUG_PROCESS_REFERENCE_INIT & 1)
@@ -193,6 +193,6 @@
                            &stdout_id );
 
-        assert( (error == 0) , __FUNCTION__ , "cannot open stdout pseudo file" );
-        assert( (stdout_id == 1) , __FUNCTION__ , "stdout index must be 1" );
+        assert( (error == 0) , "cannot open stdout pseudo file" );
+        assert( (stdout_id == 1) , "stdout index must be 1" );
 
 #if (DEBUG_PROCESS_REFERENCE_INIT & 1)
@@ -211,6 +211,6 @@
                            &stderr_id );
 
-        assert( (error == 0) , __FUNCTION__ , "cannot open stderr pseudo file" );
-        assert( (stderr_id == 2) , __FUNCTION__ , "stderr index must be 2" );
+        assert( (error == 0) , "cannot open stderr pseudo file" );
+        assert( (stderr_id == 2) , "stderr index must be 2" );
 
 #if (DEBUG_PROCESS_REFERENCE_INIT & 1)
@@ -330,5 +330,5 @@
     // reset local process vmm
     error = vmm_init( local_process );
-    assert( (error == 0) , __FUNCTION__ , "cannot initialize VMM\n");
+    assert( (error == 0) , "cannot initialize VMM\n");
 
     // reset process file descriptors array
@@ -393,5 +393,5 @@
     pid_t       pid = process->pid;
 
-	assert( (process->th_nr == 0) , __FUNCTION__ ,
+	assert( (process->th_nr == 0) ,
     "process %x in cluster %x has still active threads", pid , local_cxy );
 
@@ -511,5 +511,5 @@
     assert( ((type == DELETE_ALL_THREADS ) ||
              (type == BLOCK_ALL_THREADS )  ||
-             (type == UNBLOCK_ALL_THREADS )), __FUNCTION__ , "illegal action type" );
+             (type == UNBLOCK_ALL_THREADS )), "illegal action type" );
              
 
@@ -843,5 +843,5 @@
         xptr_t ref_xp = cluster_get_reference_process_from_pid( pid );
 
-        assert( (ref_xp != XPTR_NULL) , __FUNCTION__ , "illegal pid\n" );
+        assert( (ref_xp != XPTR_NULL) , "illegal pid\n" );
 
         // allocate memory for local process descriptor
@@ -1046,7 +1046,7 @@
  
 
-    assert( (process != NULL) , __FUNCTION__ , "process argument is NULL" );
-
-    assert( (thread != NULL) , __FUNCTION__ , "thread argument is NULL" );
+    assert( (process != NULL) , "process argument is NULL" );
+
+    assert( (thread != NULL) , "thread argument is NULL" );
 
     // take lock protecting th_tbl, depending on thread type:
@@ -1089,5 +1089,5 @@
     uint32_t count;  // number of threads in local process descriptor
 
-    assert( (thread != NULL) , __FUNCTION__ , "thread argument is NULL" );
+    assert( (thread != NULL) , "thread argument is NULL" );
 
     process_t * process = thread->process;
@@ -1101,5 +1101,5 @@
     count = process->th_nr;
 
-    assert( (count > 0) , __FUNCTION__ , "process th_nr cannot be 0\n" );
+    assert( (count > 0) , "process th_nr cannot be 0\n" );
 
     // remove thread from th_tbl[]
@@ -1140,5 +1140,5 @@
     ref_xp = hal_remote_lwd( XPTR( parent_process_cxy , &parent_process_ptr->ref_xp ) );
 
-    assert( (parent_process_xp == ref_xp ) , __FUNCTION__ ,
+    assert( (parent_process_xp == ref_xp ) ,
     "parent process must be the reference process\n" );
 
@@ -1243,5 +1243,5 @@
 
     // check main thread LTID
-    assert( (LTID_FROM_TRDID(thread->trdid) == 0) , __FUNCTION__ ,
+    assert( (LTID_FROM_TRDID(thread->trdid) == 0) ,
     "main thread must have LTID == 0\n" );
 
@@ -1421,5 +1421,5 @@
     }
 
-    assert( false, __FUNCTION__, "we should not execute this code");
+    assert( false, "we should not execute this code");
  
 	return 0;
@@ -1491,5 +1491,5 @@
 	process = process_alloc(); 
 	
-    assert( (process != NULL), __FUNCTION__,
+    assert( (process != NULL),
     "no memory for process descriptor in cluster %x\n", local_cxy  );
 
@@ -1497,8 +1497,8 @@
     error = cluster_pid_alloc( process , &pid );
 
-    assert( (error == 0), __FUNCTION__,
+    assert( (error == 0),
     "cannot allocate PID in cluster %x\n", local_cxy );
 
-    assert( (pid == 1) , __FUNCTION__,
+    assert( (pid == 1) ,
     "process INIT must be first process in cluster 0\n" );
 
@@ -1518,5 +1518,5 @@
 	                    &file_id );
 
-	assert( (error == 0), __FUNCTION__,
+	assert( (error == 0),
     "failed to open file <%s>\n", CONFIG_PROCESS_INIT_PATH );
 
@@ -1525,5 +1525,5 @@
 	error = elf_load_process( file_xp , process );
 
-	assert( (error == 0), __FUNCTION__,
+	assert( (error == 0),
     "cannot access .elf file <%s>\n", CONFIG_PROCESS_INIT_PATH );
 
@@ -1553,8 +1553,8 @@
                                 &thread );
 
-	assert( (error == 0), __FUNCTION__,
+	assert( (error == 0),
     "cannot create main thread for <%s>\n", CONFIG_PROCESS_INIT_PATH );
 
-    assert( (thread->trdid == 0), __FUNCTION__,
+    assert( (thread->trdid == 0),
     "main thread must have index 0 for <%s>\n", CONFIG_PROCESS_INIT_PATH );
 
@@ -1631,5 +1631,5 @@
     txt_file_xp = hal_remote_lwd( XPTR( owner_cxy , &owner_ptr->fd_array.array[0] ) );
 
-    assert( (txt_file_xp != XPTR_NULL) , __FUNCTION__ , 
+    assert( (txt_file_xp != XPTR_NULL) ,
     "process must be attached to one TXT terminal\n" ); 
 
@@ -1695,5 +1695,5 @@
     }
 
-    assert( false , __FUNCTION__ , "no free TXT terminal found" );
+    assert( false , "no free TXT terminal found" );
 
     return -1;
@@ -1712,10 +1712,10 @@
 
     // check process is in owner cluster
-    assert( (CXY_FROM_PID( process->pid ) == local_cxy) , __FUNCTION__ ,
+    assert( (CXY_FROM_PID( process->pid ) == local_cxy) ,
     "process descriptor not in owner cluster" );
 
     // check terminal index
     assert( (txt_id < LOCAL_CLUSTER->nb_txt_channels) ,
-    __FUNCTION__ , "illegal TXT terminal index" );
+    "illegal TXT terminal index" );
 
     // get pointers on TXT_RX[txt_id] chdev
@@ -1761,5 +1761,5 @@
     // check process descriptor in owner cluster
     process_pid = hal_remote_lw( XPTR( process_cxy , &process_ptr->pid ) );
-    assert( (CXY_FROM_PID( process_pid ) == process_cxy ) , __FUNCTION__ ,
+    assert( (CXY_FROM_PID( process_pid ) == process_cxy ) ,
     "process descriptor not in owner cluster" );
 
@@ -1811,5 +1811,5 @@
 
     // check owner cluster
-    assert( (process_cxy == CXY_FROM_PID( process_pid )) , __FUNCTION__,
+    assert( (process_cxy == CXY_FROM_PID( process_pid )) ,
     "process descriptor not in owner cluster\n" );
 
@@ -1864,5 +1864,5 @@
 
     // check owner cluster
-    assert( (process_cxy == CXY_FROM_PID( process_pid )) , __FUNCTION__,
+    assert( (process_cxy == CXY_FROM_PID( process_pid )) ,
     "process descriptor not in owner cluster\n" );
 
@@ -1922,5 +1922,5 @@
 
             // PANIC if KSH not found
-            assert( false , __FUNCTION__ , "KSH process not found for TXT %d" ); 
+            assert( false , "KSH process not found for TXT %d" );
 
             return;
@@ -1995,5 +1995,5 @@
     // check owner cluster
     pid_t process_pid = hal_remote_lw( XPTR( process_cxy , &process_ptr->pid ) );
-    assert( (process_cxy == CXY_FROM_PID( process_pid )) , __FUNCTION__,
+    assert( (process_cxy == CXY_FROM_PID( process_pid )) ,
     "process descriptor not in owner cluster\n" );
 
@@ -2041,5 +2041,5 @@
     
     assert( (txt_id < LOCAL_CLUSTER->nb_txt_channels) ,
-    __FUNCTION__ , "illegal TXT terminal index" );
+    "illegal TXT terminal index" );
 
     // get pointers on TXT0 chdev